/****************************************/
/* Might and Magic book1 ϊvO */
/****************************************/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define	MAXBYTE			65535
#define	S_LEN			128

int main(int argc, char **argv)
{
	FILE	*infp, *outfp;
	FILE	*ptfp;

	unsigned char	buff[MAXBYTE];

	char	fname[S_LEN];

	int		progno;
	int		flen;

	int		c,i,j,k;
	int		stadd,ptno;

	if (argc != 2) {
		fprintf(stderr, "Usage: convmm1 program-no. \n");
		exit(1);
	}

	progno = atoi(argv[1]);

	if (progno < 0 || progno > 9 || progno == 7) {
		printf("Program number error\n");
		exit(1);
	}

/* open files */

	sprintf(fname,"prog%d.bin",progno);
	if ((infp = fopen(fname, "rb")) == NULL) {
		perror(fname);
		exit(1);
	}

	sprintf(fname,"prog%d_p6.bin",progno);
	if ((outfp = fopen(fname, "wb")) == NULL) {
		perror(fname);
		exit(1);
	}

/* for test */
//	sprintf(fname,"test.bin",progno);
//	if ((ptfp = fopen(fname, "rb")) == NULL) {
//		perror(fname);
//		exit(1);
//	}


/* t@Cǂݏo */
	i = 0x100;
	while ( (c = fgetc(infp)) != EOF) {
		buff[i] = c;
		i ++;
	}
	flen = i;


/********************************/
/********** ʂ̕ϊ **********/
/********************************/

	buff[0x1704] = 0x00; /* nop */
	buff[0x1705] = 0x00; /* nop */


/********************************/
/********** ʂ̕ϊ **********/
/********************************/

	switch (progno) {
		case 0:	/* vO #0 */
				/* B:0b:00:01:01 */

/* for test */
//			for (i = 0x1709;;i ++) {
//				if ( (c = fgetc(ptfp)) == EOF) {
//					break;
//				}
//				buff[i] = c;
//			}


			buff[0x3eba] = 0x00; /* ^COύX */
			buff[0x3ebb] = 0x08; /* ^COύX */

			buff[0x49b8] = 0xa0; /* SSGݒ */
			buff[0x49c2] = 0xa1; /* SSGݒ */
			buff[0x49f6] = 0xa0; /* SSGݒ */
			buff[0x4a00] = 0xa1; /* SSGݒ */
			buff[0x4a34] = 0xa0; /* SSGݒ */
			buff[0x4a3e] = 0xa1; /* SSGݒ */

			break;

		case 1:	/* vO #1 */
				/* A:18:01:01:01 */

			buff[0x2bbd] = 'E'; /* bZ[WύX */
			buff[0x2bbe] = 'S'; /* bZ[WύX */
			buff[0x2bbf] = 'C'; /* bZ[WύX */

			if (buff[0x5c01] == 0x44) {
				buff[0x4684] = 0x00; /* ^COύX */
				buff[0x4685] = 0x08; /* ^COύX */
				buff[0x5c01] = 0xa0; /* SSGݒ */
				buff[0x5c0b] = 0xa1; /* SSGݒ */
				buff[0x5c3f] = 0xa0; /* SSGݒ */
				buff[0x5c49] = 0xa1; /* SSGݒ */
				buff[0x5c7d] = 0xa0; /* SSGݒ */
				buff[0x5c87] = 0xa1; /* SSGݒ */
				buff[0x4684] = 0x00; /* ^COύX */
				buff[0x4685] = 0x04; /* ^COύX */
			} else if (buff[0x5c01-3] == 0x44) {
				buff[0x4684-3] = 0x00; /* ^COύX */
				buff[0x4685-3] = 0x08; /* ^COύX */
				buff[0x5c01-3] = 0xa0; /* SSGݒ */
				buff[0x5c0b-3] = 0xa1; /* SSGݒ */
				buff[0x5c3f-3] = 0xa0; /* SSGݒ */
				buff[0x5c49-3] = 0xa1; /* SSGݒ */
				buff[0x5c7d-3] = 0xa0; /* SSGݒ */
				buff[0x5c87-3] = 0xa1; /* SSGݒ */
			} else {
				printf("version illigal\n");
				exit(1);
			}

			break;

		case 2:	/* vO #2 */
				/* B:0e:00:01:01 */

			buff[0x3d89] = 0x00; /* ^COύX */
			buff[0x3d8a] = 0x08; /* ^COύX */

			buff[0x523c] = 0xa0; /* SSGݒ */
			buff[0x5246] = 0xa1; /* SSGݒ */
			buff[0x527a] = 0xa0; /* SSGݒ */
			buff[0x5284] = 0xa1; /* SSGݒ */
			buff[0x52b8] = 0xa0; /* SSGݒ */
			buff[0x52c2] = 0xa1; /* SSGݒ */

			break;

		case 3:
		case 4:
		case 5:
				/* vO #3 */
				/* B:12:00:01:01 */

			if (buff[0x6dd5] == 0x44) {
				buff[0x568a] = 0x00; /* ^COύX */
				buff[0x568b] = 0x08; /* ^COύX */
				buff[0x6dd5] = 0xa0; /* SSGݒ */
				buff[0x6ddf] = 0xa1; /* SSGݒ */
				buff[0x6e13] = 0xa0; /* SSGݒ */
				buff[0x6e1d] = 0xa1; /* SSGݒ */
				buff[0x6e51] = 0xa0; /* SSGݒ */
				buff[0x6e5b] = 0xa1; /* SSGݒ */
			} else if (buff[0x6dd5+3] == 0x44) {
				buff[0x568a+3] = 0x00; /* ^COύX */
				buff[0x568b+3] = 0x08; /* ^COύX */
				buff[0x6dd5+3] = 0xa0; /* SSGݒ */
				buff[0x6ddf+3] = 0xa1; /* SSGݒ */
				buff[0x6e13+3] = 0xa0; /* SSGݒ */
				buff[0x6e1d+3] = 0xa1; /* SSGݒ */
				buff[0x6e51+3] = 0xa0; /* SSGݒ */
				buff[0x6e5b+3] = 0xa1; /* SSGݒ */
			} else {
				printf("version illigal\n");
				exit(1);
			}

			break;

		case 6:	/* vO #6 */
				/* A:1e:01:01:01 */

			buff[0x32fa] = 0x00; /* ^COύX */
			buff[0x32fb] = 0x08; /* ^COύX */

			buff[0x2b74] = 0xa0; /* SSGݒ */
			buff[0x2b7e] = 0xa1; /* SSGݒ */

			break;

		case 8:	/* vO #8 */
				/* A:1b:01:01:01 */

			buff[0x2485] = 0x00; /* ^COύX */
			buff[0x2486] = 0x08; /* ^COύX */

			break;

		case 9:	/* vO #9 */
				/* A:21:01:01:01 */

			buff[0x47c4] = 0xcd; /* ^COvZύX */
			buff[0x47c5] = 0x06; /* ^COvZύX */
			buff[0x47c6] = 0x01; /* ^COvZύX */
			buff[0x47c7] = 0x00; /* ^COvZύX */
			buff[0x47c8] = 0x00; /* ^COvZύX */

			buff[0x7cc5] = 0x00; /* ^COύX */
			buff[0x7cc6] = 0x04; /* ^COύX */

			buff[0x8cbf] = 0xa0; /* SSGݒ */
			buff[0x8cc9] = 0xa1; /* SSGݒ */

			break;



		default:
			break;
	}



/* t@C */
	for (i = 0x100;i < flen;i ++) {
		fputc(buff[i],outfp);
	}

	fclose(outfp);
	fclose(infp);


	return(0);
}
